/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#define EXPORT_ONCE __declspec(selectany)
// Data imported from the original executable

typedef struct  
{
  char Unit_Type;				//0
  char Paper_Doll;
  char Unknown1;
  char Unknown2;
  char Unknown3;
  char Unknown4;
  char Unknown5;
  char Unknown6;
  char Unknown7;
  char Unknown8;
  char Facing;					//10
  char Unknown9;
  unsigned char TUs_Current;
  char HPs_Current;
  char Stun;
  char EUs_Current;
  char React_Current;
  char Strength;
  char F_Armor_Current;
  char L_Armor_Current;
  char R_Armor_Current;			//20
  char B_Armor_Current;
  char U_Armor_Current;
  char Firing_Acc;
  char Throw_Acc;
  unsigned char TUs_Max;
  char HPs_Max;
  char EUs_Max;
  char React_Max;
  char F_Armor_Max;
  char L_Armor_Max;				//30
  char R_Armor_Max;
  char B_Armor_Max;
  char U_Armor_Max;
  char UnknownA;
  char EU_Recharge;
  char UnknownB;
  char Psi_Skill;
  char obdata_index;
  char VPs;
  char soldier_index;			//40
  char UnknownC;
  char Rank;
  char UnknownD;
  char Aggression;
  char EU_Usage;
  char HWP_Turret;
  char UnknownE;
  char UnknownF;
  char Stand_Height;
  char Crouch_Height;			//50
  char UnknownG;
  char UnknownH;
  char L_Hand_Item;
  char R_Hand_Item;
  char UnknownI;
  char Close_Acc;
  char Psi_Strength;
  char Morale;
  char Bravery;
  char UnknownJ;				//60
  char UnknownK;
  char Scanner_Blip;
  char Head_Fatal;
  char Torso_Fatal;
  char R_Arm_Fatal;
  char L_Arm_Fatal;
  char R_Leg_Fatal;
  char L_Leg_Fatal;
  char UnknownL;
  char UnknownM;				//70
  char UnknownN;
  char UnknownO;
  char Intelligence;
  char UnknownP;
  char UnknownQ;
  char Mission_Count;
  char UnknownR;
  short Kills;
  char React_Count;				//80
  char Shot_Count;
  char Rod_Count;
  char Throw_Count;
  char Psi_Count;
  char Panic_Count;				//85
  char Name[26];
  char UnknownS;
  char Inventory_Access;
  char On_Fire;
  char Gender;
  char Race;
  char Turret_Weapon;
  char Turret_Ammo;
  char Unknown;
  char Bitflags;
  char UnknownT;
  char UnknownU;
  char UnknownV;
} unitref_dat;

EXPORT_ONCE int (*GetUnitEncumberance)(int)=(int (__cdecl *)(int))0x413820;
EXPORT_ONCE void (*DrawNumber)(int number, int color, int dst, __int16 useSmallFont)=(void (__cdecl *)(int,int,int,short))0x450A10;
EXPORT_ONCE void (*DrawNumber2)(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)=(void (__cdecl *)(int,int,__int16,__int16,int))0x450B00;



EXPORT_ONCE void (*DrawSmallLetter)(int chr, int col, int dst)=(void (__cdecl *)(int,int,int))0x450660;
EXPORT_ONCE void (*DrawString)(char *str, int color, __int16 ypos, __int16 xpos, int smallFont)=(void (__cdecl *)(char *str, int color, __int16 ypos, __int16 xpos, int smallFont))0x4501A0;
EXPORT_ONCE int (*UpdateRadarStats)(int base)=(int (__cdecl *)(int))0x439D10;
EXPORT_ONCE int (*GetRandom_0_n)(int n)=(int (__cdecl *)(int))0x43D850;

EXPORT_ONCE int (*LoadFile)(void *dstbuf, int filename)=(int (__cdecl *)(void *,int))0x43B5A0;
EXPORT_ONCE int (*AlienTakeActionAfterShootDown)(void *pUFOCraft, void * pAttackingCraft)=(int (__cdecl *)(void *,void *))0x432A80;
                            
EXPORT_ONCE int (*GetClickedButton)()=(int (__cdecl *)())0x450F10;
EXPORT_ONCE int (*LoadGFXRessources)(__int16 resourcePackId)=(int (__cdecl *)(__int16 resourcePackId))0x409BD0;
EXPORT_ONCE int (*DrawRankIcon)(int dst, int src, int width)=(int (__cdecl *)(int dst, int src, int width))0x4254A0;
EXPORT_ONCE int (*Tactical_KillUnit)(int)=(int (__cdecl *)(int))0x40E450;
EXPORT_ONCE void (*LoadTacticalGame)(char *)=(void (__cdecl *)(char *))0x416E90;
EXPORT_ONCE void (*LoadGeographGame)(char *)=(void (__cdecl *)(char *))0x44B9B0;
                            
EXPORT_ONCE void (*SaveTacticalData)(char *)=(void (__cdecl *)(char *))0x416020;
EXPORT_ONCE int (*PerformReactionFire)()=(int (__cdecl *)())0x40FA20;
EXPORT_ONCE void (*ComputeVisibleAliens)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)=(void (__cdecl *)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance))0x42EA40;
EXPORT_ONCE int (*AdjustShotWithAccuracy)()=(int (__cdecl *)())0x40DAE0;
EXPORT_ONCE int (*DD_SurfaceUnlock)()=(int (__cdecl *)())0x45C860;
EXPORT_ONCE char * (*DD_SurfaceLock)()=(char * (__cdecl *)())0x45C800;
EXPORT_ONCE int (*DD_SurfaceFlip)()=(int (__cdecl *)())0x45C880;

EXPORT_ONCE short *language=(short *)0x4783AC;
EXPORT_ONCE int *carretPosition=(int *)0x4A3F6C;
EXPORT_ONCE unitref_dat **currentUnit_pUnitRef=(unitref_dat **)0x4A3E88;
EXPORT_ONCE short *unitIdx=(short *)0x4783B4;
EXPORT_ONCE short *tactical_mainState=(short *)0x4781DC;
EXPORT_ONCE int *CurrentMidiPlaying=(int *)0x4758E8;
EXPORT_ONCE short *currentBaseIdx=(short *)0x49AAC8;
EXPORT_ONCE short *tac_debug=(short *)0x477BD2;
EXPORT_ONCE short *tac_debug_alienPuppies=(short *)0x46D1F2;
EXPORT_ONCE short *tac_currentTUReserveMode=(short *)0x478464;
EXPORT_ONCE short *difficultyLevel=(short *)0x49B85E;

EXPORT_ONCE char *tac_misdata=(char *)0x4A3EA0;
EXPORT_ONCE char **locationList=(char **)0x49AAB0;
EXPORT_ONCE char **craftList=(char **)0x49AB18;

EXPORT_ONCE char **StringTable_geoscape=(char **)0x47A3A4;
EXPORT_ONCE char **StringTable_battlescape=(char **)0x49D660;
 
EXPORT_ONCE short *DrawText_leftBorder=(short *)0x4782AE;
EXPORT_ONCE short *DrawText_rightBorder=(short *)0x4782B0;
EXPORT_ONCE short *currentGFXPackage=(short *)0x4782A6;

EXPORT_ONCE short **smokeTabRessources=(short **)0x4ADE3C;
EXPORT_ONCE char **smokePCKRessources=(char **)0x4A3F7C;
EXPORT_ONCE char **BackBuffer=(char **)0x4ADE30;

EXPORT_ONCE char *IsDuringInitialUPSExplosion=(char *)0x477EB4;
                    
EXPORT_ONCE char *unitpos_dat=(char *)0x4A2C40;
EXPORT_ONCE short *currentWeapon_damageType=(short *)0x4783EA;

EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4A3134;
EXPORT_ONCE int **pMap=(int **)0x4A3144;
EXPORT_ONCE unsigned char *pGeodata=(unsigned char *)0x4A6AE0;

EXPORT_ONCE unsigned char **pBaseList=(unsigned char **)0x49AAD8;

EXPORT_ONCE unsigned char *Tac_Show_LaunchRocket_Icon=(unsigned char *)0x4782B7;
EXPORT_ONCE unsigned char *Tac_numRocketWayPoints=(unsigned char *)0x478478;


EXPORT_ONCE short *Tac_RocketWayPoints=(short *)0x49DA00;
EXPORT_ONCE short **file_ufograph_cursor_tab=(short **)0x4A6A80;
EXPORT_ONCE char **file_ufograph_cursor_pck=(char **)0x4A5FB0;
EXPORT_ONCE int (*DrawPCKSprite)(__int16, __int16, int, int)=(int (__cdecl *)(__int16,__int16,int,int))0x430640;

EXPORT_ONCE short *mouse_num_click1=(short *)0x4A3F68;
EXPORT_ONCE short *mouse_num_click2=(short *)0x4A59E8;
EXPORT_ONCE short *mouseCursorId=(short *)0x4781D0;


EXPORT_ONCE short *tac_clickedTile_xpos=(short *)0x4781CC;
EXPORT_ONCE short *tac_clickedTile_ypos=(short *)0x4781CA;

EXPORT_ONCE short *tac_xview=(short *)0x4781D4;
EXPORT_ONCE short *tac_yview=(short *)0x4781D2;
EXPORT_ONCE short *tac_zview=(short *)0x46B77E;


EXPORT_ONCE char **currentUnit_pUnitPos=(char **)0x4A5FC0;
EXPORT_ONCE void (*SetFiringPointOrigin)(char *)=(void (__cdecl *)(char *))0x40D8E0;

EXPORT_ONCE short *accuracy=(short *)0x478422;
EXPORT_ONCE short *WeaponMenu_NumEntries=(short *)0x4783CC;

typedef struct {
	short actionType;
	short accuracy;
	short TUusage;
	short weaponStrength;
	short damageType;
} menu_item;

EXPORT_ONCE menu_item *WeaponMenu_Items=(menu_item *)0x4A6AA0;

EXPORT_ONCE short *currentWeapon_damage=(short *)0x4783E8;

EXPORT_ONCE void (*SetTacticalViewPos)(int ypos, int xpos, __int16 zpos)=(void (__cdecl *)(int ypos, int xpos, __int16 zpos))0x412060;

EXPORT_ONCE void (*DoDamageToShotTile)()=(void (__cdecl *)())0x40DC90;
EXPORT_ONCE void (*FixShotTile)()=(void (__cdecl *)())0x427090;
                            
EXPORT_ONCE short *Tactical_weaponHasHitSomeone=(short *)0x4A282A;
EXPORT_ONCE short *Tactical_weaponHasHitSomething=(short *)0x4A2830;

EXPORT_ONCE short *impactArmorSide=(short *)0x4A2838;
EXPORT_ONCE void (*Tactical_DoDamageToUnit)(__int16 impactSide, __int16 playAnimation)=(void (__cdecl *)(__int16 impactSide, __int16 playAnimation))0x40DEA0;

EXPORT_ONCE short *Tactical_StatusErrorMessage=(short *)0x4781E8;

EXPORT_ONCE int (*GetRelativePositioning)(int y1, int x1, int y2, int x2)=(int (__cdecl *)(int y1, int x1, int y2, int x2))0x421790;
EXPORT_ONCE void (*TryChangeUnitOrientation)(int pUnitPos, int orientation)=(void (__cdecl *)(int pUnitPos, int orientation))0x421830;


EXPORT_ONCE short *currentUnit_ypos=(short *)0x4781E0;
EXPORT_ONCE short *currentUnit_xpos=(short *)0x4781E2;
EXPORT_ONCE short *currentUnit_idx=(short *)0x4781E6;


EXPORT_ONCE int *mouse_ypos=(int *)0x46E3E0;


                            

EXPORT_ONCE short *needsToUpdateTerrainLightSources=(short *)0x49DB10;
EXPORT_ONCE short *needsToUpdateSoldiersLightSources=(short *)0x4A2842;

EXPORT_ONCE void (*TacticalComputeTerrainLightSources)()=(void (__cdecl *)())0x418940;
EXPORT_ONCE void (*TacticalComputeSoldiersLightSources)()=(void (__cdecl *)())0x418780;

EXPORT_ONCE char **currentDamagedUnit_pUnitPos=(char **)0x4A285C;
EXPORT_ONCE void (*GenerateExplosion)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16)=(void (__cdecl *)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16))0x40B420;

#pragma pack(1)
typedef struct
{
	short active;
	char *pObpos;
} prox_entry;

EXPORT_ONCE prox_entry *tac_prox_mine_list=(prox_entry *)0x478208;
EXPORT_ONCE char *pObpos_dat=(char *)0x4A5FE0;

EXPORT_ONCE void (*ActAccordingToTacticalState)()=(void (__cdecl *)())0x41FE30;

EXPORT_ONCE void (*SetCurrentUnit)(int)=(void (__cdecl *)(int))0x4202A0;

//EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4A3134;
EXPORT_ONCE short *tac_mapZSize=(short *)0x4A5FB8;

EXPORT_ONCE void (*CreateButton)(int,int,int,int,int,char *)=(void (__cdecl *)(int,int,int,int,int,char *))0x450D00;
EXPORT_ONCE void (*WaitTillMouseButtonsAreReleased)()=(void (__cdecl *)())0x43D8A0;
EXPORT_ONCE int (*CheckForClickedButton)()=(int (__cdecl *)())0x450FF0;
EXPORT_ONCE short *ui_numButtons=(short *)0x478462;
EXPORT_ONCE short (*GetFreeObPosRef)()=(short (__cdecl *)())0x40EBD0;
